// CustomMessageView.cpp : implementation of the CCustomMessageView class
//

#include "stdafx.h"
#include "CustomMessage.h"

#include "CustomMessageDoc.h"
#include "CustomMessageView.h"

#include <atlconv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomMessageView

IMPLEMENT_DYNCREATE(CCustomMessageView, CDocHostHtmlView)

BEGIN_MESSAGE_MAP(CCustomMessageView, CDocHostHtmlView)
	//{{AFX_MSG_MAP(CCustomMessageView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomMessageView construction/destruction

CCustomMessageView::CCustomMessageView()
{
	// TODO: add construction code here

}

CCustomMessageView::~CCustomMessageView()
{
}

BOOL CCustomMessageView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CDocHostHtmlView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CCustomMessageView drawing

void CCustomMessageView::OnDraw(CDC* pDC)
{
	CCustomMessageDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

void CCustomMessageView::OnInitialUpdate()
{
	CDocHostHtmlView::OnInitialUpdate();

	LoadFromResource( IDR_MAINPAGE );
}

/////////////////////////////////////////////////////////////////////////////
// CCustomMessageView diagnostics

#ifdef _DEBUG
void CCustomMessageView::AssertValid() const
{
	CDocHostHtmlView::AssertValid();
}

void CCustomMessageView::Dump(CDumpContext& dc) const
{
	CDocHostHtmlView::Dump(dc);
}

CCustomMessageDoc* CCustomMessageView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCustomMessageDoc)));
	return (CCustomMessageDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCustomMessageView message handlers

HRESULT CCustomMessageView::OnShowMessage(HWND hwnd, LPOLESTR lpstrText, LPOLESTR lpstrCaption,
										  DWORD dwType, LPOLESTR lpstrHelpFile,
										  DWORD dwHelpContext, LRESULT * plResult)
{
	USES_CONVERSION;

	const UINT nMsgBoxTitle = 2213;

	TCHAR szCaption[ 100 ];
	HINSTANCE hinstSHDOCLC = NULL;
	bool bFreeLibrary = false;

	hinstSHDOCLC = ::GetModuleHandle( _T("SHDOCLC.DLL") );

	if (!hinstSHDOCLC)
	{
		hinstSHDOCLC = ::LoadLibrary( _T("SHDOCLC.DLL") );
		if (hinstSHDOCLC)
		{
			bFreeLibrary = true;
		}
	}

	if (hinstSHDOCLC)
	{
		if (::LoadString( hinstSHDOCLC, nMsgBoxTitle, szCaption, 100 ))
		{
			if (::lstrcmp( szCaption, OLE2CT( lpstrCaption ) ) == 0)
				lpstrCaption = OLESTR("CustomMessage");  // application name
		}
	}

	if (dwType & MB_ICONEXCLAMATION)
	{
		dwType &= (~MB_ICONEXCLAMATION);
		dwType |= MB_ICONINFORMATION;
	}

	*plResult = ::MessageBox( hwnd, OLE2CT( lpstrText ), OLE2CT( lpstrCaption ), dwType );

	if (bFreeLibrary && hinstSHDOCLC)
	{
		::FreeLibrary( hinstSHDOCLC );
	}

	return S_OK;
}