#if !defined(AFX_DOCHOSTHTMLVIEW_H__37829C74_D5BD_43F0_9F7A_BAD0B87E4479__INCLUDED_)
#define AFX_DOCHOSTHTMLVIEW_H__37829C74_D5BD_43F0_9F7A_BAD0B87E4479__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DocHostHtmlView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDocHostHtmlView html view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif
#include <afxhtml.h>

#ifndef _DOCHOSTSITE_H_
#include <mshtmhst.h>
#endif

class CDocHostHtmlView : public CHtmlView
{
protected:
	CDocHostHtmlView();           // protected constructor used by dynamic creation
	virtual ~CDocHostHtmlView();
	DECLARE_DYNCREATE(CDocHostHtmlView)

// Attributes
private:
	class CDocHostOccManager * m_pOccManager;

// Overrides
protected:
	// CHtmlView overrides
	virtual BOOL Create(LPCTSTR lpszClassName,
		LPCTSTR lpszWindowName,
		DWORD dwStyle,
		const RECT& rect,
		CWnd* pParentWnd,
		UINT nID,
		CCreateContext* pContext = NULL);
#if _MFC_VER >= 0x0700
	virtual BOOL CreateControlSite(COleControlContainer* pContainer, 
	   COleControlSite** ppSite, UINT nID, REFCLSID clsid);
#endif

	// IDocHostUIHandler overridables
	virtual HRESULT OnDocWindowActivate(BOOL fActivate);
	virtual HRESULT OnEnableModeless(BOOL fActivate);
	virtual HRESULT OnFilterDataObject(IDataObject * pDataObject,
		IDataObject ** ppDataObject);
	virtual HRESULT OnFrameWindowActivate(BOOL fActivate);
	virtual HRESULT OnGetDropTarget(IDropTarget * pDroptarget,
		IDropTarget ** ppDropTarget);
	virtual HRESULT OnGetExternal(IDispatch ** lppDispatch);
	virtual HRESULT OnGetHostInfo(DOCHOSTUIINFO * pInfo);
	virtual HRESULT OnGetOptionKeyPath(LPOLESTR * pchKey,
		DWORD dwReserved);
	virtual HRESULT OnHideUI();
	virtual HRESULT OnResizeBorder(LPCRECT prcBorder,
		IOleInPlaceUIWindow * pUIWindow,
		BOOL fFrameWindow);
	virtual HRESULT OnShowContextMenu(DWORD dwID,
		LPPOINT ppt,
		IUnknown * pcmdtReserved,
		IDispatch * pdispReserved);
	virtual HRESULT OnShowUI(DWORD dwID,
		IOleInPlaceActiveObject * pActiveObject,
		IOleCommandTarget * pCommandTarget,
		IOleInPlaceFrame * pFrame,
		IOleInPlaceUIWindow * pDoc);
	virtual HRESULT OnTranslateAccelerator(LPMSG lpMsg,
		const GUID * pguidCmdGroup,
		DWORD nCmdID);
	virtual HRESULT OnTranslateUrl(DWORD dwTranslate,
		OLECHAR * pchURLIn,
		OLECHAR ** pchURLOut);
	virtual HRESULT OnUpdateUI();

#if (_WIN32_IE >= 0x0501) // IE 5.5 and higher

	// IDocHostUIHandler2 overrideables
	virtual HRESULT OnGetOverrideKeyPath(LPOLESTR * pchKey,
		DWORD dw);

#endif

	// IDocHostShowUI overridables
	virtual HRESULT OnShowHelp(HWND hwnd,
		LPOLESTR pszHelpFile,
		UINT uCommand,
		DWORD dwData,
		POINT ptMouse,
		IDispatch * pDispatchObjectHit);
	virtual HRESULT OnShowMessage(HWND hwnd,
		LPOLESTR lpstrText,
		LPOLESTR lpstrCaption,
		DWORD dwType,
		LPOLESTR lpstrHelpFile,
		DWORD dwHelpContext,
		LRESULT * plResult);

#ifdef _DOCHOSTSITE_H_
	friend class CDocHostSite::XDocHostShowUI;
	friend class CDocHostSite::XDocHostUIHandler;
#if (_WIN32_IE >= 0x0501) // IE 5.5 and higher
	friend class CDocHostSite::XDocHostUIHandler2;
#endif
#endif
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DOCHOSTHTMLVIEW_H__37829C74_D5BD_43F0_9F7A_BAD0B87E4479__INCLUDED_)
